import java.text.DecimalFormat;
import java.util.ArrayList;


/**
 * 
 * Trida pro zobrazeni histrogramu
 * 
 * @author jsobisek@zcu.students.cz
 * @version 1.0
 *
 */
public class Histogram {
	
	/**
	 * Konstruktor
	 */
	public Histogram(){
		
	}
	
	/**
	 * Vytiskne histogram
	 * 
	 * @param countGenNumbers
	 * @param countIntervals
	 * @param onePartSize
	 * @param arIntervals
	 */
	public void printHistogram(int countGenNumbers, int countIntervals, double onePartSize, ArrayList<Double> arIntervals){
		
		// iterujeme seznam s counterama v jednotlivych intervalech
		for(Double d : arIntervals){
			
			double densityInOneInterval = d / (countGenNumbers * onePartSize); // kazdou hodnotu aktualizujeme a ulozima na stejny misto 
			arIntervals.set(arIntervals.indexOf(d), densityInOneInterval);
		}
				
		int countInFirstInterval = (int) (arIntervals.get(0) * 100000 / 4 ); // ziskani delitele pro pomerne zobrazeni histogramu
		
		//vypis histogramu
		for(int i = 0; i < arIntervals.size(); i++){
			System.out.println(getIntervalStartNumber((double)i * onePartSize) + ":" + convertDoubleToStars(arIntervals.get(i), countInFirstInterval ));
		}
		System.out.println("\n\n");

	}
	
	/**
	 * Ziska prvni mez intevalu
	 * 
	 * @param startNumber
	 * @return
	 */
	private String getIntervalStartNumber(double startNumber){
		
		// definovani ciselneho formatu pro vypis
		DecimalFormat formatter = new DecimalFormat();
		formatter.setMinimumIntegerDigits(2);
		formatter.setMaximumFractionDigits(4);
		formatter.setMinimumFractionDigits(4);
		
		return formatter.format(startNumber);
	}
	
	/**
	 * Prevede cislo double pomerne na hvezdicky ***
	 * 
	 * @param number
	 * @return
	 */
	private String convertDoubleToStars(double number, int countInFirstInterval){
		
		StringBuffer sb = new StringBuffer("");
        int no = (int) (number * 100000) ;
        int starCount = no / countInFirstInterval;
        
        // vytvareni vystupu
        for(int i = 0; i < starCount; i++){
        	sb.append("*");
        }
		
		return sb.toString();
	}

}
