import java.util.ArrayList;


/**
 * 
 * Trida pro kontrolovany vypocet
 * 
 * @author jsobisek@zcu.students.cz
 * @version 1.0
 *
 */
public class Triangle {
	
	Generator generator = new Generator();
	Histogram histogram = new Histogram();
	
	/**
	 * Konstructor
	 * 
	 */
	public Triangle(){
		
	}
	
	/**
	 * Ziskani teoretickeho rozptylu
	 * 
	 * @param paramA
	 * @return
	 */
	public double getTheoreticalD(double paramA){
		
		double teoretickyRozpyl = Math.pow(paramA, 2) / 6;
		return teoretickyRozpyl;
		
	}
	
	/**
	 * Vypocet
	 * 
	 * @param countGenNumbers
	 * @param paramA
	 * @param countIntervals
	 */
	public void compute(int countGenNumbers, double paramA, int countIntervals){
		
		ArrayList<Double> arIntervals = new ArrayList<Double>();
		
		for(int i = 0; i < countIntervals; i++){
			arIntervals.add((double) 0);  // na zacatku naplnime hodnotou nula kazdy prvek
		}
		
		double sumaE = 0;
		double sumaD = 0;
		double vypocitaneE = 0;
		double vypocitaneD = 0;
		double onePartSize = 0; // velikost jednoho dilku
			
		onePartSize = (2 * paramA) / countIntervals; // vypocitam velikost jednoho dilku
		
		// cyklus pro hlavni vypocet
		for(int i = 0; i < countGenNumbers; i++){
			
			double randomNumber = generator.getRandomNumber(paramA); // vygenerujeme nahodne cislo s troj. rozdelenim
			
				for(int j = 0; j < arIntervals.size(); j++){
					
					// pokud nejsme na poslednim intervalu
					if(!(j == arIntervals.size() - 1)){
						
						// trefili jsme interval cisla
						if ( ((j * onePartSize) <= randomNumber) & ( randomNumber < ((j+1) * onePartSize )) ){
							
							arIntervals.set(j, arIntervals.get(j) + 1); // zvysime pocitadlo + 1
							break;
						}
					}
					// jsme na poslednim intervalu
					else {
						// tak prvek musi patrit do posledniho intervalu
						arIntervals.set(j, arIntervals.get(j) + 1);
					}
				}
		
			sumaE = sumaE + randomNumber; 
			sumaD = sumaD + Math.pow(randomNumber, 2); 			
		}
		
		vypocitaneE = sumaE / countGenNumbers; // vypocteme stredni hodnotu
		vypocitaneD = (sumaD / countGenNumbers) - Math.pow(vypocitaneE, 2); // vypocitame rozptyl 
		
		// zobrazime prvni cast vystupu
		System.out.println("E_teorie=" + paramA);
		System.out.println("D_teorie=" + getTheoreticalD(paramA));
		System.out.println("E_vypocet=" + vypocitaneE);
		System.out.println("D_vypocet=" + vypocitaneD + "\n");
		
		/* zobrazime hosdnoty vstupnich parametru  */
		System.out.println("pocet generovanch cisel: " + String.valueOf(countGenNumbers));
		System.out.println("param a: " + String.valueOf(paramA)); 
		System.out.println("pocet intervalu: " + String.valueOf(countIntervals) + "\n"); 
		
		
		// zobrazime histogram
		histogram.printHistogram(countGenNumbers, countIntervals, onePartSize, arIntervals); 
				
	}

}



